<?php

class Controller
{
	protected $database;
	protected $template;
	protected $autoRender;

	public function __construct()
	{
		$this->database = Database::getInstance();

		//$this->template = new Gears(Config::$templateDirectory);
		//$this->template->setLayout(Config::$templateLayout);
		$this->template = new Template();
		$this->loadHelpers();
		$this->autoRender = true;
	}
	
	function __beforeAction()
	{
		
	}
	
	function __beforeRender()
	{
		
	}
	
	/**
	 * Sets a variable in the template.
	 */
	protected function set($a, $b)
	{
		$this->template->set($a, $b);
	}

	/**
	 * Sets the template to render.
	 */
	public function setTemplate($layout)
	{
		$this->template->setTemplate($layout);
	}
	
	/**
	 * Renders the template.
	 */
	public function render($template = null)
	{
		$this->__beforeRender();
		$this->autoRender = false;
		$this->template->display($template);
	}
	
	/**
	 * Sets the page title.
	 */
	protected function title($title)
	{
		$this->set('title', $title);
	}
	
	protected function redirect($url)
	{
		header('Location: ' . Router::baseUrl() . $url);
		exit;
	}
	
	protected function loadHelpers()
	{
		$this->template->Html = new Html();
		$this->template->Form = new Form();
	}
	
	public function isAutoRender()
	{
		return $this->autoRender;
	}
}