<?php

class Template
{
	protected $_variables;
	protected $_layout;
	protected $_template;
	protected $_path;
	protected $_extention;

	public function __construct()
	{
		$this->_variables = array();
		$this->_layout = 'default';
		$this->_template = '';
		$this->_path = 'templates/';
		$this->_extention = 'tpl';
	}

	public function set($key, $value = null)
	{
		$temp = array();
		if (is_array($key)) {
			/*if (is_array($value)) { //Both the key and value are arrays
				$temp = array_combine($key, $value);
			}
			else { //array('text1' => 'Hello,', 'text2' => ' world!')
				$temp = $key;
			}*/
			$temp = $key;
		}
		else {
			$temp[$key] = $value;
		}
		$this->_variables = array_merge($this->_variables, $temp);
		//print_r($this->_variables);
	}
	
	public function display($template = null)
	{
		if ($template == null)
			$template = $this->_template;
		$tpl = $this->render($template);
		if (!$tpl)
			$this->error404();
		echo $tpl;
	}

	public function render($template)
	{
		$file = $this->_path.$template.'.'.$this->_extention;
		if (!is_file($file))
			return false;
		extract($this->_variables, EXTR_SKIP);

		ob_start();
		require $file;
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}
	
	public function error404()
	{
		$tpl = $this->render('error404');
		if (!$tpl) //Fool me twice...
			throw new Exception('Error 404, file(s) not found!');
	}
	
	public function getLayout()
	{
		return $this->_layout;
	}

	public function setLayout($layout)
	{
		$this->_layout = $layout;
	}

	public function getTemplate()
	{
		return $this->_template;
	}

	public function setTemplate($template)
	{
		$this->_template = $template;
	}

	public function getPath()
	{
		return $this->_path;
	}

	public function setPath($path)
	{
		$this->_path = $path;
	}

	public function getExtention()
	{
		return $this->_extention;
	}

	public function setExtention($extention)
	{
		$this->_extention = $extention;
	}
}